#ifndef HAVE_DECISION_TREE_H
#define HAVE_DECISION_TREE_H

#include "attributes.h"

#define DTREE_OP_EQ 1
#define DTREE_OP_LE 2
#define DTREE_OP_GT 3

typedef struct _dtree_t {
  int dtree_op;
  int dtree_ival;
  char *dtree_sval;
  struct _dtree_t *dtree_else;

#ifdef TRISH2
  attribute_t *dtree_attribute;
#else
  bunch_element_ref_t dtree_attribute;
#endif
  struct _dtree_t *dtree_test;
} dtree_t;

dtree_t *dtree_new(int op, int ival, char *sval);
void dtree_free(dtree_t *dt);

#ifdef TRISH2
void dtree_attribute(dtree_t *dtree, patricia_t *al, const char *aname);
#else
void dtree_attribute(dtree_t *dtree, association_t *al, const char *aname);
#endif

void dtree_else(dtree_t *dtree, dtree_t *dte);

#ifdef TRISH2
void dtree_print(FILE *f, patricia_t *al, dtree_t *dtree, int depth);
#else
void dtree_print(FILE *f, association_t *al, dtree_t *dtree, int depth);
#endif

#endif
