#ifndef HAVE_EVAL_ATTRIBUTE_H
#define HAVE_EVAL_ATTRIBUTE_H

#include "attributes.h"
#include "noun_phrase.h"

#ifdef TRISH2
#include <patricia.h>
#else
#include <association.h>
#endif

#define EVAL_ATTRIBUTE_TYPE_INT    1
#define EVAL_ATTRIBUTE_TYPE_STRING 2

typedef struct {
  int ea_type;
  int ea_ival;
  char *ea_sval;
} eval_attribute_t;

#ifdef TRISH2
eval_attribute_t *eval_attribute(patricia_t *dict_list, int ctx_attr, attribute_t *attr, noun_phrase_t *np);
eval_attribute_t *eval_attribute_name(patricia_t *dict_list, int ctx_attr, patricia_t *attr_list, const char *aname, noun_phrase_t *np);
#else
eval_attribute_t *eval_attribute(association_t *dict_list, int ctx_attr, attribute_t *attr, noun_phrase_t *np);
eval_attribute_t *eval_attribute_ref(association_t *dict_list, int ctx_attr, association_t *attr_list, bunch_element_ref_t aref, noun_phrase_t *np);
eval_attribute_t *eval_attribute_name(association_t *dict_list, int ctx_attr, association_t *attr_list, const char *aname, noun_phrase_t *np);
#endif

#endif
