#ifndef HAVE_EXPLORE_H
#define HAVE_EXPLORE_H

#include "attributes.h"
#include "decision_tree.h"
#include "noun_phrase.h"

#include <libxml/tree.h>

#ifdef TRISH2
typedef struct {
  int ex_ctx;
  patricia_t *ex_dict_list;
  patricia_t *ex_attr_list;
  int ex_max_following_range;
  int ex_max_preceding_range;
  dtree_t *ex_dt;
} explore_t;
#else
typedef struct {
  int ex_ctx;
  association_t *ex_dict_list;
  association_t *ex_attr_list;
  int ex_max_following_range;
  int ex_max_preceding_range;
  dtree_t *ex_dt;
} explore_t;
#endif

explore_t *explore_new();
void explore_free(explore_t *ex);

void explore_attributes(explore_t *ex, xmlDoc *doc);
void explore_dtree(explore_t *ex, xmlDoc *doc);

const char *explore_get_label(explore_t *ex, noun_phrase_t *np, FILE *f);

#endif
